import heapq
import numpy


def find_start(maze):
    starts = numpy.argwhere(maze == "S")
    assert len(starts) == 1

    return tuple(starts[0])


def maze_neighs():
    return []


def reached_destination():
    return True


def path_visibility():
    return float("nan")


def oracle_path(maze, sensors, probs):
    """Finds the path with the lowest expected visibility."""
    # TODO: Finish this oracle for the best path based on Dijkstra

    nx, ny = maze.shape
    start = find_start(maze)

    queue = [(float("nan"), [start])]
    dists = numpy.full(maze.shape, numpy.nan)
    dists[start] = float("nan")

    while queue:
        dist, path = heapq.heappop(queue)

        if reached_destination():
            return dist, path

        # TODO: Check and skip the node, if it was already explored
        # (no decrease_priority in heapq)

        for neigh in maze_neighs():
            new_path = path + [neigh]
            alt = path_visibility()

            # TODO: Check if this new path reaches neigh in a less visible way
            # then the previous best, and if so, add it to the queue.
            heapq.heappush(queue, (alt, new_path))
